checkRequire("Lua_TimeLineData");
checkRequire("Lua_TimeLineAddCamEffect");
checkRequire("Lua_TimeLineAddEffect");
checkRequire("Lua_TimeLineCollect");
checkRequire("Lua_TimeLineCreateObject");
checkRequire("Lua_TimeLineDisposeObj");
checkRequire("Lua_TimeLineEnd");
checkRequire("Lua_TimeLineJumpPoint");
checkRequire("Lua_TimeLineJumpToTf");
checkRequire("Lua_TimeLineLuaEvent");
checkRequire("Lua_TimeLineMoveTo");
checkRequire("Lua_TimeLineOpenWin");
checkRequire("Lua_TimeLinePlayEffect");
checkRequire("Lua_TimeLineRemoveCamEffect");
checkRequire("Lua_TimeLineRemoveEffect");
checkRequire("Lua_TimeLineSetAct");
Lua_ActingManager = class("Lua_ActingManager");
Lua_ActingManager.JUMP_TO_TF = 1;
Lua_ActingManager.JUMP_TO_POINT = 2;
Lua_ActingManager.CREATE_OBJ = 3;
Lua_ActingManager.DO_ACTION = 4;
Lua_ActingManager.MOVE_TO = 5;
Lua_ActingManager.END = 6;
Lua_ActingManager.DISPOSE_OBJ = 7;
Lua_ActingManager.SET_ACT = 8;
Lua_ActingManager.LUA_EVENT = 9;
Lua_ActingManager.OPEN_WIN = 10;
Lua_ActingManager.ADD_CAM_EFFECT = 11;
Lua_ActingManager.REMOVE_CAM_EFFECT = 12;
Lua_ActingManager.ADD_EFFECT = 13;
Lua_ActingManager.REMOVE_EFFECT = 14;
Lua_ActingManager.DO_COLLECT = 15;
Lua_ActingManager.PLAY_EFFECT = 16;
function Lua_ActingManager:ctor()
	self.classDic = {};
	self.classDic[Lua_ActingManager.JUMP_TO_TF] = Lua_TimeLineJumpToTf;
	self.classDic[Lua_ActingManager.JUMP_TO_POINT] = Lua_TimeLineJumpPoint;
	self.classDic[Lua_ActingManager.CREATE_OBJ] = Lua_TimeLineCreateObject;
	self.classDic[Lua_ActingManager.DO_ACTION] = Lua_TimeLineSetAct;
	self.classDic[Lua_ActingManager.MOVE_TO] = Lua_TimeLineMoveTo;
	self.classDic[Lua_ActingManager.END] = Lua_TimeLineEnd;
	self.classDic[Lua_ActingManager.DISPOSE_OBJ] = Lua_TimeLineDisposeObj;
	self.classDic[Lua_ActingManager.SET_ACT] = Lua_TimeLineSetAct;
	self.classDic[Lua_ActingManager.LUA_EVENT] = Lua_TimeLineLuaEvent;
	self.classDic[Lua_ActingManager.OPEN_WIN] = Lua_TimeLineOpenWin;
	self.classDic[Lua_ActingManager.ADD_CAM_EFFECT] = Lua_TimeLineAddCamEffect;
	self.classDic[Lua_ActingManager.REMOVE_CAM_EFFECT] = Lua_TimeLineRemoveCamEffect;
	self.classDic[Lua_ActingManager.ADD_EFFECT] = Lua_TimeLineAddEffect;
	self.classDic[Lua_ActingManager.REMOVE_EFFECT] = Lua_TimeLineRemoveEffect;
	self.classDic[Lua_ActingManager.DO_COLLECT] = Lua_TimeLineCollect;
	self.classDic[Lua_ActingManager.PLAY_EFFECT] = Lua_TimeLinePlayEffect;
	self:dispose();
end
function Lua_ActingManager:dispose()
	self.createThingList = Array();
	self.createCamEffectList = Array();

	self.timeLineList = Array();
	self.startTime = getTime();
end
function Lua_ActingManager:startAct(actId)
	self._curAct = actId;
	GlobalVar.isActing = true;
	self.timeLineList = Array();
	self:decodeData();
	self:doStart();
end
function Lua_ActingManager:decodeData()
	local configStr = "act_"..self._curAct;
	local endPos = getConfig({configStr, "endPos"});
	self.endScene = endPos[1];
    self.endPos = Vector3(endPos[2],endPos[3],endPos[4]);
    local timeList = getConfig({configStr, "timeList"});
    local len = #timeList;
    for i=1,len do
    	local t = timeList[i].actType;
    	local tld = self:getTimeDataByType(t);
    	tld:decodeConfig(timeList[i]);
    	self.timeLineList:add(tld);
    end
end
function Lua_ActingManager:doStart()
	self.startTime = getTime();
	Lua_CommonUtil.addTimer("Lua_ActingManager", 0.01, self, self.onDoingAct);
end
function Lua_ActingManager:onDoingAct()
	if self.timeLineList:getSize() > 0 then
            local tld = self.timeLineList[1];
            local pt = getTime() - self.startTime;
            if pt >= tld.startTime then
                tld:doAction();
                self.timeLineList:remove(1);
            end
    else
    	self:endAct();
    	ActingManager.getInstance():endAct();
    end
end
function Lua_ActingManager:endAct()
	Lua_CommonUtil.removeTimer(self, self.onDoingAct);
end
function Lua_ActingManager:getTimeDataByType(actType)
	if self.classDic[actType] == nil then
		return Lua_TimeLineData.new();
	end
	return self.classDic[actType].new();
end