Lua_TimeLineJumpToTf = class("Lua_TimeLineJumpToTf", Lua_TimeLineData);
function Lua_TimeLineJumpToTf:decodeConfig(t)
	self:superCall("decodeConfig", t);
	self.pos = Vector3(t.pos[1],t.pos[2],t.pos[3]);
	self.rot = Vector3(t.rot[1],t.rot[2],t.rot[3]);
	if t.speed ~= nil then
		self.speed = t.speed;
	else
		self.speed = Lua_CommonUtil.getCommonConfig("map_jump_speed", 1)
	end
	if t.actSpeed ~= nil then
		self.actSpeed = t.actSpeed;
	else
		self.actSpeed = Lua_CommonUtil.getCommonConfig("map_jump_acc", 1)
	end

	self.tobjId = t.tobjId;
    self.endAct = t.endAct;
    self.bone = t.bone;
    self.dir = t.dir;
    self.offsetY = t.offsetY;
end
function Lua_TimeLineJumpToTf:doAction()
	self:superCall("doAction");

	local ap = self:getAnimalPlayer(self.targetId);
	if ap == nil then
		return;
	end
	local tp = ThingUtil.instance:getThingById(self.tobjId);
    if self.bone == "root" then
        ap:setJumpOffset(self.dir, self.pos, Quaternion.Euler(self.rot));
        ap:jumpTo(tp.root.transform, self.offsetY, self.speed, actSpeed, -1, true, false, false, self.endAct);
    else
        local tf = ContainerUtil.findBoneTransform(tp.root.transform, self.bone);
        ap:setJumpOffset(self.dir, self.pos, Quaternion.Euler(self.rot));
        ap:jumpTo(tf, self.offsetY, self.speed, self.actSpeed, -1, true, false, false, self.endAct);
    end
end